local gcrypt = require("luagcrypt")
local sha_proxy = {}

function sha_proxy:new()
  local fake_instance = {
    sha = gcrypt.Hash(gcrypt.MD_SHA256),
  }

  function fake_instance:update(data)
    self.sha:write(data)
  end

  function fake_instance:final()
    local str = self.sha:read(gcrypt.MD_SHA256)
    return (str:gsub(".", function(char) return string.format("%02x", char:byte()) end))
  end

  return fake_instance
end

return sha_proxy
